<?php
/**
 * append BASEURI to all urls, links, etc (except for external links)
 *
 * @author oleksiy
 */
class CBaseLinkViewRenderer extends CViewRenderer {

    protected function generateViewFile($sourceFile, $viewFile)
    {
        $input = file_get_contents($sourceFile);
        $baseurl = Yii::app()->request->baseUrl;

        $patterns = array(
            '/<(a|link)(.*?)href=[\"\'](?!http|mailto|javascript|ftp:)(.*?)[\"\'](.*?)>/',
            '/<(img|script|input)(.*?)src=[\"\'](?!http|ftp|file:)(.*?)[\"\'](.*?)>/',
            '/<form(.*?)action=[\"\'](?!http|ftp:)(.*?)[\"\'](.*?)>/',
            '/background=[\"\'](?!http|ftp:)(.*?)[\"\']/',
            '/background[\s]{0,}:[\s]{0,}url\((?!http|ftp:)(.*?)\)/');;

        $replacements = array(
            '<$1$2href="'.$baseurl.'$3"$4>',
            '<$1$2src="'.$baseurl.'$3"$4>',
            '<form$1action="'.$baseurl.'$2"$3>',
            'background="'.$baseurl.'$1"',
            'background:url('.$baseurl.'$1)');

        $ouput = preg_replace($patterns, $replacements, $input);

        file_put_contents($viewFile, $ouput);
    }

}
?>
